
#include "simpletools.h"
#include "wifi.h"
#include "abdrive.h"
#include "ping.h"
#include "servo.h"

int event, id, handle;
int navId;
char buttonCmd;
char direction;
int speedLeft = 0, speedRight = 0;


int main()
{  
  wifi_start(31, 30, 115200, WX_ALL_COM);     //the mode in which the bot will operate (see wifi module manual for other modes)
  navId = wifi_listen(HTTP, "/path1"); //tell the bot to listen on the same path created by the webpage

  while(1)
  {
    wifi_poll(&event, &id, &handle); //grab from the path 
    //print("event: %c, id: %d, handle: %d\r", 
               //event,     id,     handle);
    //wifi_print(GET, handle, "%d", ping_cm(8));           
  
    if(event == 'P') //if it's a post request
    {
      if(id == navId)
      {
        print("Incoming POST request\r");
        pause(500);
        wifi_scan(POST, handle, "go%c", &buttonCmd);
        print("go=%c\n", buttonCmd);
      }        
    }
    else if(event=='G') //if it's a get request
    {
      int dist = ping_cm(8);
      //the check to see if the bot is okay to move (once the bot is moving it cannot stop unless here)
      //because a get request happens every half second, this check ensures the bot doesn't run into something WHILE it's already moving
      if(dist > 10 || direction =='b') 
      {
        wifi_print(GET, handle, "%d%c%d%c%d%c%c", dist, ':', speedLeft, ':', speedRight, ':', 't');  //generate the response string seperated by ':' delimiter
      }
      else 
      {
       wifi_print(GET, handle, "%d%c%d%c%d%c%c", dist, ':', speedLeft, ':', speedRight, ':', 'f'); 
       drive_speed(0, 0);
       speedLeft = 0;
       speedRight = 0; 
      }                     
    }      
     
    if(buttonCmd != 0)
    {
  
      switch(buttonCmd) //main switch case (more cases could be added for more functionalitity
      {
        case 'D': //case D and B set the bot to move in a certain direction
          direction='f';
          break;
        case 'B':
          direction='b';
          break;
        case 'S':
          if(direction=='f')
          {
           speedLeft = speedLeft - 10;
           speedRight = speedRight - 10;
           if(speedLeft < 0 || speedRight < 0)
           {
            speedLeft = 0;
            speedRight = 0; 
           }              
          }
          else if(direction=='b')
          {
            speedLeft = speedLeft + 10;
            speedRight = speedRight + 10;
            if(speedLeft > 0 || speedRight > 0)
            {
             speedLeft = 0;
             speedRight = 0;
              
            }              
          }            
          break;                 
        case 'G':
          if(direction=='f')
          {
           speedLeft += 10;
           speedRight += 10; 
          }
          else
          {
           speedLeft -= 10;
           speedRight -= 10; 
          }                        
          break;
       case 'L':
          if(direction=='f')
          {
           speedLeft = speedLeft - 5; 
            
          }
          if(direction=='b')
          {
            
           speedRight= speedRight - 5; 
          }  
          break;                      
       case 'R':
          if(direction=='f')
          {
           speedRight=speedRight-5; 
          }
          if(direction=='b')
          {
           speedLeft=speedLeft-5; 
          }                      
          break;
       case 'F':
          speedLeft = 0;
          speedRight = 0;
          break;

      } 
       
        if(ping_cm(8) <10 && direction=='f') //additional check to make sure the bot doesn't move when a user presses a button for it
        {
          speedLeft = 0;
          speedRight = 0;
        }        
        drive_speed(speedLeft, speedRight); //actually tells the bot to move
      
              
      buttonCmd = 0;
    }
               
    pause(200);
  }    
}

